<template>
  <div>
    <v-snackbar
      v-model="snackbar"
      bottom
      :timeout="-1"
      content-class="d-flex align-center"
    >
      <div class="player pt-2 pb-2">
        <v-slider
          class="align-center flex-grow-1"
          :value="progress"
          @change="changeSlider"
          @end="endedMoveSlider"
          @start="startedMoveSlider"
          @input="inputSlider"
          hide-details
        >
          <template slot="prepend">
            <v-btn
              class="ml-0 mr-3"
              fab
              small
              @click="togglePlay"
            >
              <v-icon v-text="playIcon"/>
            </v-btn>
          </template>
          <template slot="append">
          <span
            class="body-2 audio-time"
            style="white-space: nowrap;"
          >
            {{currentTime + '&nbsp;/&nbsp;' + durationTime}}
          </span>
          </template>
        </v-slider>
      </div>
      <audio-download
        class="ml-3"
        :url="src"
      />
      <v-btn
        class="ml-3"
        icon
        @click="close"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
    <audio ref="media" :src="src"/>
  </div>
</template>

<script>
  import { secondsToTime } from '../utils/helper'
  import { mapMutations } from 'vuex'
  import AudioDownload from './AudioDownload'

  export default {
    components: {
      AudioDownload
    },
    data () {
      return {
        isSliderMoving: false,
        ended: false,
        current: 0,
        duration: 0
      }
    },
    mounted () {
      const m = this.$refs.media
      m.addEventListener('durationchange', this.onDurationChange)
      m.addEventListener('timeupdate', this.onTimeUpdate)
      m.addEventListener('ended', this.onEnded)
      m.addEventListener('playing', this.onPlaying)
      m.addEventListener('pause', this.onPause)
      m.addEventListener('error', this.onError)
    },
    beforeDestroy () {
      const m = this.$refs.media
      m.removeEventListener('durationchange', this.onDurationChange)
      m.removeEventListener('timeupdate', this.onTimeUpdate)
      m.removeEventListener('ended', this.onEnded)
      m.removeEventListener('playing', this.onPlaying)
      m.removeEventListener('pause', this.onPause)
      m.removeEventListener('error', this.onError)
    },
    watch: {
      status (status) {
        switch (status) {
          case 'playing':
            this.play()
            break
          case 'paused':
            this.pause()
            break
        }
      },
      '$route' () {
        if (this.snackbar) this.closePlayer()
      }
    },
    computed: {
      snackbar: {
        get () {
          return this.$store.state.media.snackbar
        },
        set (val) {
          this.setSnackbar(val)
        }
      },
      src () {
        const media = this.$store.state.media.file
        if (!media) return ''
        if (typeof media === 'string') {
          return media
        } else {
          try {
            return URL.createObjectURL(media)
          } catch (e) {
            console.log(e)
            return ''
          }
        }
      },
      status () {
        return this.$store.state.media.status
      },
      progress () {
        return this.current * 100 / this.duration
      },
      currentTime () {
        return secondsToTime(this.current).join(':')
      },
      durationTime () {
        return secondsToTime(this.duration).join(':')
      },
      playIcon () {
        switch (this.status) {
          case 'playing':
            return 'mdi-pause'
          case 'finished':
            return 'mdi-replay'
          default: return 'mdi-play'
        }
      }
    },
    methods: {
      ...mapMutations('media', ['setStatus', 'setSnackbar', 'closePlayer']),
      close () {
        this.closePlayer()
        this.$emit('close')
      },
      play () {
        this.$refs.media.play()
      },
      pause () {
        this.$refs.media.pause()
      },
      seek (seconds) {
        this.$refs.media.currentTime = seconds
      },
      togglePlay () {
        if (this.ended) this.seek(0)
        this.status === 'playing' ? this.setStatus('paused') : this.setStatus('playing')
      },
      changeSlider (val) {
        this.$refs.media.currentTime = val * this.duration / 100
      },
      startedMoveSlider () {
        this.setStatus('paused')
        this.isSliderMoving = true
      },
      endedMoveSlider () {
        this.setStatus('playing')
        this.isSliderMoving = false
      },
      inputSlider (val) {
        if (!this.isSliderMoving) return
        this.current = val * this.duration / 100
      },
      // Отправляется, когда начинается воспроизведение медиа (в первый раз, после паузы или после перезапуска).
      onPlaying () {
        // this.playing = true
        this.ended = false
      },
      // Отправляется, когда воспроизведение приостановлено.
      onPause () {
        // this.playing = false
      },
      // Может быть отправлено, например, когда медиа загружено достаточно для того, чтобы продолжительность уже была известна.
      onDurationChange () {
        this.duration = this.$refs.media.duration
        // this.playing = false
        this.ended = false
        this.$emit('onLoaded')
      },
      // Отправляется, когда изменяется значение атрибута currentTime.
      onTimeUpdate () {
        this.current = this.$refs.media.currentTime
      },
      // Отправляется, когда воспроизведение завершено.
      onEnded () {
        this.$store.commit('media/setStatus', 'finished')
        this.ended = true
      },
      onError (e) {
        if (this.src) {
          console.log('audio error', e)
          this.$emit('onError', e)
          this.setStatus('paused')
          this.setSnackbar(false)
          this.$store.commit('setError', this.$t('snackbar.error'))
        }
      }
    }
  }
</script>

<style lang="scss">
  .player {
    width: 100%;
  }

  @media screen and (min-width: 600px) {
    .player {
      min-width: 530px;
    }
  }
</style>
